unit UnitExemple;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RunOne, StdCtrls, ShellAPI;

type
  TMainForm = class(TForm)
    LblParamRecu: TLabel;
    ButtonRunApp: TButton;
    LblParam: TLabel;
    LblParamToSend: TLabel;
    EditParamToSend: TEdit;
    RunOne1: TRunOne;
    procedure RunOne1FirstRun(Sender: TObject);
    procedure RunOne1AlreadyRun(Sender: TObject);
    procedure ButtonRunAppClick(Sender: TObject);
    procedure RunOne1GetParam(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.RunOne1FirstRun(Sender: TObject);
begin
  ShowMessage('Cette Instance est la premire de cette application');
end;

procedure TMainForm.RunOne1AlreadyRun(Sender: TObject);
var
  Awnser:Integer;
begin
  Awnser:=MessageBox(Application.Handle,PChar('Il existe dja une Instance de cette application.'+#10#13+'Voulez-vous ouvrir une nouvelle Instance?'),'Confirmation',MB_YESNOCANCEL or MB_ICONQUESTION	or MB_APPLMODAL);
  Case Awnser of
    IDYES:RunOne1.StopOtherRun:=False;
    IDNO:RunOne1.StopOtherRun:=True;
    IDCANCEL: Begin //Si on ne veux pas ouvrir l'application
              RunOne1.StopOtherRun:=True; //Evite l'envoie du message
              Application.Terminate;  // puis on ferme
              End;
  end;
end;

procedure TMainForm.RunOne1GetParam(Sender: TObject);
Var
  I:Integer;
begin
  If RunOne1.CountParam <> 0 then ShowMessage('Reception de nouveau(x) paramtre(s)'); // test de la correction du Bug
  LblParamRecu.Caption:=InttoStr(RunOne1.CountParam)+' Paramtre(s): ';
  For I:=1 to RunOne1.CountParam do
    LblParamRecu.Caption:=LblParamRecu.Caption+'"'+RunOne1.StrParam(I)+'" ';
end;

procedure TMainForm.ButtonRunAppClick(Sender: TObject);
Var
  FileName,ParamSend:String;
begin
  FileName:=RunOne1.StrParam(0);
  If EditParamToSend.Text<>''then
    ParamSend:='"'+EditParamToSend.Text+'"'
  Else
    ParamSend:='';
  ShellExecute(Handle, 'Open', PChar(FileName), PChar(ParamSend), nil, SW_SHOW);
  EditParamToSend.Clear;
end;

end.
